package com.gl.mapscli.examples.isup;

import com.gl.mapscli.isup.*;

public class IsupPlaceCall {

	public static void main(String[] args) throws InterruptedException {
		// create isup client
		IsupClient isupClient = new IsupClient("192.168.12.189", 10024);
		isupClient.setTestbedProfile("Sig-Card1_B-Port_1.xml");
		String protocolType = "ISUP";

		// connect client to server
		if (isupClient.connect()) {
			System.out.println("ISUP Client Connected");
			// Thread.sleep(2000);
			// initialize isup client testbed
			int testbedStatus = isupClient.initialize();
			if (testbedStatus == 0) {
				System.out.println("ISUP Testbed Started");
				Thread.sleep(5000);

				// check MAPSCLI & GL Server Status
				System.out.println("Server Health Status: " + isupClient.serverHealthStatus(protocolType));
				// start call script
				IsupCall isupCall = isupClient.startCallScript("HIGH", "PLACE_CALL");
				if (isupCall.getErrorCode() == 0) {
					System.out.println("ISUP Place Call Script Initiated");

					// Enable or Disable traffic recording, valid string values:
					// enable = 1 or disable = 0
					// System.out.println("SetRecordFileVar: " +
					// isupCall.setVariable("RecordFile", 1));
					// System.out.println("SetCardNumber: " +
					// isupCall.setVariable("CardNumber", 1));
					// System.out.println("SetGivenCN: " +
					// isupCall.setVariable("Timeslot", 1));

					// Thread.sleep(2000);
					while (true) {
						System.out.println("Waiting for MTP3 to go UP");
						if ((isupCall.getTransportStatus()) == 0)
							break;
					}
					System.out.println("MTP3 is UP");
					System.out.println("Server Health Status: " + isupClient.serverHealthStatus(protocolType));
					if (isupCall.placeCall() == 0) {
						System.out.println("Placing ISUP Call");
						Thread.sleep(3000);
						System.out.println("ISUPCallSatus: " + isupCall.getCallStatus());
						Thread.sleep(2000);
						// System.out.println("Hold Call: " +
						// isupCall.holdCall());
						// Thread.sleep(1000);
						// System.out.println("Retrieve Call: " +
						// isupCall.retrieveCall());
						// Thread.sleep(1000);
						// System.out.println("Suspend Call: " +
						// isupCall.suspendCall());
						// Thread.sleep(1000);
						// System.out.println("Resume Call: " +
						// isupCall.resumeCall());
						// Thread.sleep(4000);
						/* tdm Traffic Actions */

						/* Receive File */
						// System.out.println(
						// "RxFile: " + isupCall.tdmReceiveFile("MAPS\\Recv
						// Files\\ISUP\\Test.pcm", 5000));
						// System.out.println("RxFileComplete: " +
						// isupCall.tdmReceiveFileWaitForCompletion(7000));

						/* Send File */
						/**
						 * Traffic file examples: for T1: mu-law
						 * samples\\vijay.pcm for E1: A-Law
						 * Samples\\luvshack.pcm
						 */
						// System.out.println("TxFile: " +
						// isupCall.tdmSendFile("mu-law samples\\vijay.pcm",
						// 6000));
						// System.out.println("TxFileComplete: " +
						// isupCall.tdmSendFileWaitForCompletion(7000));

						// /* Receive Tone */
						// System.out.println("RxTone: " +
						// isupCall.tdmDetectTones(10000));
						// System.out.println("RxToneComplete: " +
						// isupCall.tdmWaitForToneDetection(2000));

						/* Get detected tone */
						// Thread.sleep(2000);
						// TdmTone tdmTone = isupCall.tdmGetDetectedTone();
						// System.out.println("ToneInfo: " +
						// tdmTone.getFrequency1() + " " + tdmTone.getPower1() +
						// " "
						// + tdmTone.getFrequency2() + " " + tdmTone.getPower2()
						// + " " + tdmTone.getDuration());
						/* Send Tone: */
						// System.out.println("TxTone: " +
						// isupCall.tdmSendTones(1004, 0, "-10.00", 10000));
						// System.out.println("TxToneComplete: " +
						// isupCall.tdmWaitForTxToneCompletion(11000));

						/* Detect Digits */
						// System.out.println("RxDigits: " +
						// isupCall.tdmDetectDigits(1200, 10000));
						/* Get detected digits */
						// System.out.println("GetDigits: " +
						// isupCall.tdmGetDetectedDigits());
						/* Send Digits */
						// Thread.sleep(2000);
						// System.out.println("TxDigits: "
						// + isupCall.tdmSendDigits("dtmf", "ABCD1234567890",
						// "-13.00", 80, 80));

						/* Tx FAX for Place Call */
						// System.out.println("TxFAX: " +
						// isupCall.tdmSendFax(4800, 12000,
						// "winclientserver\\faxsimulator\\send\\1.tif"));
						// System.out.println("TxFAXComplete: " +
						// isupCall.tdmSendFaxWaitForCompletion(50000));
						// Thread.sleep(1000);

						Thread.sleep(1000);
						System.out.println("Terminate Call: " + isupCall.terminateCall());
						// System.out.println("Reset Call: " +
						// isupCall.initiateReset());
						// System.out.println("Clear Call: " +
						// isupCall.clearCall());

						IsupMessage lastMsg = isupCall.getLastReceivedMessage();
						System.out.println("ISUPLastMSGRcv: " + lastMsg.getTime() + " " + lastMsg.getDirection() + " "
								+ lastMsg.getName());

						/* print message count */

						int MsgCount = isupCall.getMessageCount();
						System.out.println("ISUPMsgCount: " + MsgCount);
						for (int index = 0; index < MsgCount; index++) {
							IsupMessage msg = isupCall.getMessageInfo(index);
							System.out.println(
									"ISUPMSGInfo: " + msg.getTime() + " " + msg.getDirection() + " " + msg.getName());
							 System.out.println("ISUPMsgContent: " +
							 msg.getContent());
						}

//						System.out.println("Stop Script: " + isupClient.stopCallScript(isupCall));
//						System.out.println("Stop Testbed: " + isupClient.stopTestbedSetup());
//						System.out.println("Disconnect Client: " + isupClient.disconnect());

						Thread.sleep(1000);
					}
				}
			} else {
				System.out.println("Testbed Status: " + testbedStatus);
				System.out.println("Server Health Status: " + isupClient.serverHealthStatus(protocolType));
			}
		} else
			System.out.println("Server Health Status: " + isupClient.serverHealthStatus(protocolType));
	}
}